## Exercice 1

#Cellule à éxécuter pour importer la bibliothèque math

from math import *


## Q1

#Les calculs peuvent être directement effectués dans la console. Mais pour pouvoir vous fournir une correction, on utilise la fonction print(). En exécutant la cellule, on obtient le résultat dans l'éditeur
print(100//3) # Résultat affiché : 33, le quotient de la division de 100 par 3
print(100/3) #33.33333333336
print(100%3) #1 le reste de la division euclidienne de  100 par 3
print(10**3) #1000 le résultat de 10 au cube

##Q2

print(14.0//7.0) #2.0, le résultat est un flottant
print(14//7) #2, le résultat est un entier
print(14//7.0) #2.0, le résultat est un flottant

print(1-1/3-1/3-1/3) #1.1102230246251565e-16, différent de zéro à cause des approximations utilisées pour coder les flottants.
print(1-3*(1/3)) #0.0 grâce aux priorités opératoires, le résultat de 3*1/3 (=1) est utilisé dans la soustraction. Cela évite l'erreur précédente.

## Q3
print(sin(5*pi/2)) #1, c'est bien le résultat attendu
#ne jamais oublier le signe *, indispensable pour tout produit
print(sin(3*pi)) # 3.6739403974420594e-16, différent du résultat attendu de 0. Cela est également dû aux approximations pour coder les flottants.

##Q4
print(1 - 3*(1/3) != 1 - 1/3 - 1/3 - 1/3)
#True, en accord avec les deux calculs de Q2 qui montre que ces deux expressions ont des valeurs différentes.
print((2**4%3) == 2) #False, en accord avec 2**4%3 =1
print((4%2)+1-2**3 > (12//4)*(-2**4)) #True, en accord avec (4%2)+1-2**3=-7 et (12//4)*(-2**4) = -48

## Exercice 2

##Q1

##Q1a
print("Tant en Maths qu'en Physique, Chimie et SI, il est très important d'être à l'aise en calculs : le calcul est un outil intermédiaire entre les premières lignes écrites qui ne sont que la traduction du problème, et la conclusion, c'est donc fondamental.\nOn ne peut s'améliorer en calculs qu'en en faisant, et certainement pas en se contentant de recopier le tableau.\nRappelons enfin que l'usage de la calculatrice est le plus souvent interdit à l'écrit des concours en Mathématiques.")
#L'utilisation des '' pour encadrer la chaine de caractère est ici impossible car la chaine de caractère posssède plusieurs apostrophes

##Q1b
print('''Le campanile du Lycée Pasteur de Neuilly-sur-Seine est revêtu des quatre inscriptions suivantes : "L'heure revient, l'homme ne revient pas " ; "Chaque heure blesse, la dernière tue " ; "L'heure française sonnera toujours " ; " Quand l'heure sonne, homme soit debout ".\nElles sont gravées lors de la construction du lycée et sont antérieures à la Première Guerre mondiale.''')

##Q2
print('3'*3) #333
print('43'+'56') #4356
print('informatique'*4) #informatiqueinformatiqueinformatiqueinformatique
print("l’informatique"+ "c’est" + "chouette")#l’informatiquec’estchouette

##Exercice 3

##Q1

#A taper dans la console
a = 3 #n'affiche rien
a #affiche 3, la valeur de la variable a
print(a) #3, affiche la valeur associée à la variable a
print('a') #affiche a, qui est une chaine de caractère
print('a = ', a) #affche a=3, soit la chaine de caractère a= suivie de la valeur de la variable a

##Q2
#Il faut bien penser à réinitialiser la console entre chaque série d'instruction, afin de ne pas garder en mémoire les variables antérieures.

##1ère série :
a=4
b=2
c=b
b=a
print(a,b,c) #4,4,2

##2ème série
a=2
b=4
c=a
b=a
c=b-a
print(a,b,c) #2,2,0

##3ème série
a=4
b=2
2=a #erreur, l'assignation se fait dans l'autre sens
b=3

##4ème série
a=4
b=2
c=b
b=a
a=c
print(a,b,c) #2,4,2

##5ème série
i=3
ai=3*i
b=2*a3 #erreur, la variable a3 n'est pas définie

##6ème série
b=2
b=a #erreur, la variable a n'est pas définie

##7ème série
a=3
b=4
x=a
a=b
c=x
print(a,b,c,x) #4,4,3,3

##8ème série
a = 2
b = 2*A #erreur, la variable A n'est pas définie, différence faite entre les majuscules et minuscules

## Exercice 4

##Q1

##Changement du prénom
prenom = input("Entrer votre prénom : \n")

##Calcul de l'âge
année = int(input("Entrer votre année de naissance :"))

##Piège
année = 2000
prenom = "Super élève"
print("Etes-vous vraiment",prenom,"agé(e) de ",2022-année,'ans ?')

##Q2
'''Exécution des trois cellules à l'aide de Ctrl+Enter'''
'''L'affiche de la ligne 130 donne 'Etes-vous vraiment Super élève agé(e) de  22 ans ?' car les lignes 128 et 129 remplacent les données rentrées par l'utilisateur'''

##Q3
'''En exécutant la cellule de la ligne 121, puis celle de la ligne 124 et enfin uniquement la ligne 130 à l'aide de Alt+Enter, on affiche bien ce qui est demandé'''

##Q4
'''int() de la ligne 125 sert à transformer la chaine de caractère issue de l'instruction input en entier. Cela permet de faire le calcul 2022-année de la ligne 130'''

##Q5
##Changement du prénom
prenom = input("Entrer votre prénom : \n")
print(type(prenom)) #<class 'str'>

##Calcul de l'âge
année = int(input("Entrer votre année de naissance :"))
print(type(année)) #<class 'int'>

##Exercice 5

x=0 #on assigne la valeur 0 à la variable x
if 17%3 == 1 : #si le reste de la division de 17 par 3 vaut 1
    x = x + 1 #dans ce cas, on incrémente x de 1, c'est à dire qu'on effectue l'opération x+1 soit 0+1 et on assigne le résultat, soit 1 à la variable x
else : #dans le cas où l'égalité n'est pas vérifiée
    x-=2 #on retranche 2 à x, c'est à dire qu'on effectue la différence x-2 soit 0-2 et on assigne le résultat, soit -2 à x.
print(x) #en ajoutant cette instruction à la sortie du bloc d'instructions conditionnelle, la valeur affectée à x est affichée. On verifie ainsi que x vaut la valeur de -2 car 17%3 vaut 2 et non 1.

##Exercice 6

##Q1
a=float(input("Donner un premier nombre : \n")) #ne pas oublier de transformer les input en flottant pour faire la comparaison. Sinon, si on compare '100' et '8', c'est '8'>'100' qui a pour valeur True par exemple.
b=float(input("Donner un deuxième nombre :\n"))
if a > b :
    print(a)
elif a < b : #pas un else car on ne peut pas inclure le cas d'égalité. elif et non if car cela fait partie du même test.
    print(b)

##Q2
a=int(input("Donner un premier entier : \n"))
b=int(input("Donner un deuxième entier :\n"))
#Si l'utilisateur a donné des flottants, un message d'erreur s'affiche car il n'est pas possible convertir par exemple "102.3" en entier. Par contre float("102.3") fonctionne, tout comme float("102") qui vaut 102.0
if a%2==0 and b%2==0 : #a et b pairs signifie que les restes des divisions de a et de b par de 2 sont nuls.
    print((a+b)/2) #ne pas oublier les parenthèses pour respecter les priorités.

##Q3 avec échange simultané
a=int(input("Donner un premier entier : \n"))
b=int(input("Donner un deuxième entier :\n"))
print("a vaut",a,"et b vaut",b)
if a%5==0:
    a,b=b,a #si on fait l'échange de a puis l'échange de b, on perd la valeur de a. On doit donc faire un échange simultané ou utiliser une variable tampon.
print("a vaut",a,"et b vaut",b)

##Q3 Utilisation de la variable tampon
a=int(input("Donner un premier entier : \n"))
b=int(input("Donner un deuxième entier :\n"))
print("a vaut",a,"et b vaut",b)
if a%5==0:
    c=a
    a=b
    b=c
print("a vaut",a,"et b vaut",b)

## Exercice 7

a = float(input("Entrer a :"))
b = float(input("Entrer b :")) #Deux nombres sont demandés à l'utilisateur, (et la valeur de type str de la fonction input est bien transformée en float)
if a!=0 :
    print('''L'unique solution de ax+b=0 vaut environ''',-b/a) #si a n'est pas nul, l'équation admet une unique solution qui est -b/a
else : #si a est  nul, il y a de cas de figure selon la valeur de b
    print(''' a est nul donc l'équation ax+b=0 admet soit une infinité de solutions ou bien aucune solution''')

## Séparation des cas du else
a = float(input("Entrer a :"))
b = float(input("Entrer b :")) #Deux nombres sont demandés à l'utilisateur, (et la valeur de type str de la fonction input est bien transformée en float)
if a!=0 :
    print('''L'unique solution de ax+b=0 vaut environ''',-b/a) #si a n'est pas nul, l'équation admet une unique solution qui est -b/a
elif b==0: #et donc a =0 sinon, seule la boucle if est parcourur
    print(''' a et b sont nuls donc l'équation ax+b=0 admet une infinité de solutions ''')
else : #donc le cas où a=0 et b non nul
     print(''' a est nul et b non nul donc l'équation ax+b=0 admet aucune solution''')

## Exercice 8

##Question 1
i=0
while 3*i+1 <=100 :
    print(3*i+1 )
    i+=1
#ou
i=0
while i<=100:
    if i%3==1:
        print(i)
    i+=1

##Question 2
phrase=input('''Que dites-vous ?\n''')
b="J'adore les cours d'ITC !"
while phrase!=b:
    phrase=input('''Que dites-vous ?\n''')

##Question 3
from random import randint
S=0
while S <=16 :
    n = randint(1,10)
    print(n)
    S+=n

##Question 4
from math import * #Pour importer abs et sin
n=2
while abs(sin(n)/n) > 10**(-3) :
    n+=1
print(n) #22


##Question 5
n = eval(input('Entrer n : '))
x = 0
while x < n:
    x += 13 # Moins long de faire une addition qu'une multiplication
print(x)

##Question 6
n=1
while n!=0 :
    n=n+1 #Cette modification ne permet pas d'atteindre la valeur False pour n!=0, c'est à dire n=0.

##Question 7
u = 5
k = 0
while u >= 0.1:
    v = u
#Une variable conservant en mémoire l'avant dernier terme calculé est nécessaire, car, à l'issue de la boucle, on aura le plus petit terme < 0.1 alors qu'on cherche le terme qui précède ce fameux terme.
    # ou on affiche u*2 à la fin
    u /= 2
    k += 1
print(k-1,v) #5 0.15625

## Exercice 9

##1a
for x in range(1,1001) :#on n'oublie pas que i in  range(a,b) signifie que i prend les valeurs de a à b-1 inclus (et donc b exclus) avec un pas de 1
    print(x)

##1b
for x in range(0,1003,3):
    print(x)

##1c
for x in range(100,-1,-1) :
    print(x)

##1d
for a in range(1,11):
    for i in range(a):
        print(a)


##2
u=1
for n in range(4) : #n prend les valeurs de 0/1/2/3 pour afficher u0/u1/u2/u3 et calculer u1/u2/u3/u4
    print(u)
    u=(u+1)/(u-n)
print(u) #affichage de u4
#Affichage : 1 2 3 4 5

##3
n=int(input("Donner le rang n souhaité\n"))
u=2
for k in range(n) :
    u=u-k+1
print(u)

##4

from math import *
S=0
for k in range(1,1001) :#k prend les valeurs de 1 à 1001
    S+=log(k)
print(S)


#ou
S=0
for k in range(1000,0,-1) :#k prend les valeurs de 1000 à 1
    S+=log(k)
print(S)

#5912.128178488171
#5912.128178488164
#les deux résultats diffèrent à partir de la 11ème décimale à cause des arrondis.

##5
n = int(input("Choisir un entier n. \n"))
S=0
for k in range(0,n+1) :
    for i in range(1,k+1) :
        S+=1/(i+k)
print(round(S,4)) #affiche S en gardant uniquement 4 décimales.

## Exercice 10 : Petites fonctions

##Question 1
def somme(a,b):
    return a+b
#on ne vérifie pas si a et b sont bien des entiers, c'est à l'utilisateur de bien lire les propriétés des arguments.

#Pour tester
print(somme(2,3)) #affichage de 5 dans la console

##Question 2
def multiple(a,b):
   return a%b==0 or b%a==0
#Cette fonction renvoie un booléen.
print(multiple(2,3)) #False
print(multiple(3,6)) #True

##Question 3
from math import *
def calcule(x,y) :                       #Condition sur y : pour avoir ln défini et avoir ln(y)!=0
    if x >=0 and y > 0 and y != 1: #Condition sur x : pour la racine.
        return (sqrt(x)/log(y))

print(calcule(4,e)) #2
print(calcule(-2,1)) #None

##Question 4
def puissance(x):
    puiss = x
    while puiss < 100:
        puiss *= x
    return puiss

print(puissance(2)) #128

##Question 5
def parfait(n):
    somme = 0
    for k in range(1,n):
        if n%k == 0:
               somme += k
    return somme == n

#Nb parfaits : 6, 28, 496, 8 128, 335 503 336, 8 589 869 056

print(parfait(29)) #False
print(parfait(28)) #True

##Question 6
def bissextile(n):
    return (n%4 == 0 and n%100 != 0) or n%400 == 0

#Vrai pour 2000 et 2004 mais pas 2002

print(bissextile(2000)) #True
print(bissextile(2002)) #False

##Question 7
from random import randint
def multiple3():
    n=randint(1,10)
    print(n)
    a=n+1
    while a%3!=0:
        a+=1
    return a

print(multiple3())

